<template>
    <transition name="modal">
        <div class="modal-mask">
            <div class="modal-wrapper">
                <div class="modal-container">
                    <div class="modal-close">
                        <button @click="$emit('close')">
                            x
                        </button>
                    </div>
                    <form class="modal-body" @submit.prevent="handleSubmit">
                        <div class="modal-body__field">
                            <input id="name" v-model="user.name"
                                   :class="{ 'is-invalid': submitted && $v.user.name.$error }"
                                   @change="changeInput"
                                   >
                            <label class="name" for="name">{{ $t('services.label_name') }}</label>
                            <div v-if="submitted && !$v.user.name.required" class="invalid-feedback">{{ $t('services.error_required') }}</div>
                        </div>
                        <div class="modal-body__field">
                            <input id="email" v-model="user.email"
                                   :class="{ 'is-invalid': submitted && $v.user.email.$error }"
                                   @change="changeInput"
                                   >
                            <label class="email" for="email">{{ $t('services.label_email') }}</label>
                            <div v-if="submitted && $v.user.email.$error" class="invalid-feedback">
                                <span v-if="!$v.user.email.required">{{ $t('services.error_required') }}</span>
                                <span v-if="!$v.user.email.email">{{ $t('services.error_email') }}</span>
                            </div>
                        </div>
                        <div class="modal-body__field">
                            <input id="site" v-model="user.site"
                                   :class="{ 'is-invalid': submitted && $v.user.site.$error }"
                                   @change="changeInput"
                                   >
                            <label class="site" for="site">{{ $t('services.label_site') }}</label>
                            <div v-if="submitted && !$v.user.site.required" class="invalid-feedback">{{ $t('services.error_required') }}</div>
                        </div>
                        <div class="modal-body__field">
                            <input id="phone" v-model="user.phone" @change="changeInput">
                            <label class="tel" for="phone">{{ $t('services.label_phone') }}</label>
                        </div>
                        <div class="modal-footer">
                            <button type="submit">
                                {{ $t('services.send') }}
                            </button>
                        </div>
                    </form>

                </div>
            </div>
        </div>
    </transition>
</template>

<script>
    import Vue from 'vue'
    import Vuelidate from 'vuelidate'
    import { required, email, } from "vuelidate/lib/validators";
    Vue.use(Vuelidate)

    export default {
        data() {
            return {
                user: {
                    name: "",
                    email: "",
                    site: "",
                    phone: "",
                },
                submitted: false
            };
        },
        validations: {
            user: {
                name: { required },
                email: { required, email },
                site: { required },
            }
        },
        methods: {
            changeInput() {
                if (document.querySelector('#name').value !== "") {
                    document.querySelector('.name').classList.add('input_focus')
                } else {
                    document.querySelector('.name').classList.remove('input_focus')
                }
                if (document.querySelector('#email').value !== "") {
                    document.querySelector('.email').classList.add('input_focus')
                } else {
                    document.querySelector('.email').classList.remove('input_focus')
                }
                if (document.querySelector('#site').value !== "") {
                    document.querySelector('.site').classList.add('input_focus')
                } else {
                    document.querySelector('.site').classList.remove('input_focus')
                }
                if (document.querySelector('#phone').value !== "") {
                    document.querySelector('.tel').classList.add('input_focus')
                } else {
                    document.querySelector('.tel').classList.remove('input_focus')
                }
            },
            handleSubmit(e) {
                this.submitted = true;
                this.$v.$touch();
                if (this.$v.$invalid) {
                    return
                }
                e.preventDefault()
                this.$parent.modalRequest = false
                this.$parent.modalSuccessfully = true
            }
        }
    }
</script>

<style lang="sass">
    .modal-mask
        position: fixed
        z-index: 9998
        top: 0
        left: 0
        width: 100%
        height: 100%
        background-color: rgba(0, 0, 0, .5)
        display: table
        transition: opacity .3s ease

        .modal-wrapper
            display: table-cell
            vertical-align: middle

        .modal-container
            display: flex
            flex-direction: column
            background-color: #ffffff
            box-shadow: 0 10px 20px 0 rgba(0, 0, 0, 0.3)
            margin: auto
            padding: 40px 30px
            width: 425px
            max-width: calc(100% - 2rem)
            position: relative
            @media (max-width: 600px)
                width: 100%

        .modal-close
            display: flex
            justify-content: center
            align-items: center
            align-self: flex-end
            margin-bottom: 40px

            button
                outline: 0
                width: 30px
                height: 30px
                font-size: 20px
                border: 1px solid #000
                border-radius: 50%
                cursor: pointer

        .modal-body__field
            position: relative
            width: 100%
            margin-bottom: 20px

            .invalid-feedback
                position: absolute
                font-size: 10px
                color: red

            input
                position: relative
                border: solid 2px #ececec
                border-radius: 3px
                background-color: #fff
                font-size: 14px
                height: 50px
                width: 100%
                padding: 0 15px
                color: #444444

            label
                position: absolute
                pointer-events: none
                left: 15px
                top: 0
                line-height: 50px
                font-size: 14px
                color: #888888
                transition: 0.3s

            input:focus
                padding-top: 6px

            input:focus ~ label
                top: -12px
                color: #888888
                font-size: 10px

            .input_focus
                top: -12px
                color: #888888
                font-size: 10px

        .modal-footer
            button
                border: none
                outline: 0
                font-size: 14px
                font-weight: bold
                text-align: center
                color: #fff
                border-radius: 3px
                background-color: darkgreen
                padding: 16px 28px
                display: inline-block
                text-transform: uppercase
                cursor: pointer
                width: 100%
                transition: all 0.7s cubic-bezier(0.2, 0.8, 0, 1)

            button:disabled
                background-color: gray
                cursor: default

</style>
